from sympy import prod, symbols, Poly, Matrix, pprint, IndexedBase, itermonomials, simplify
from sympy import LC, LM, LT, reduced, ZZ, degree_list
from sympy.polys.monomials import monomial_deg
from sympy.polys.orderings import monomial_key

from sympy.polys.subresultants_qq_zz import *


A, a, b, c, x, y, z = symbols('A a b c x y z')


print('reduced monom division ::', reduced(x**2 * y + x*y**2 + y**2 ,
                                           [x*y - 1, y**2 - 1]), '\n')

"""
f = 4 * x * y**2 * z + 4 * z**2 - 5 * x**3 + 7 * x**2 * z**2

print('f = ', f, '\n' )
print('LC = ', LC(f, [z, y, x]), '\n' )
#print('LM = ', LM(f), '\n' )
print('LM = ', LM(f, [z, y, x]), '\n' )
print('LT = ', LT(f, [z, y, x]), '\n' )

monomials = [x**5 * y**2 * z, x**5 * y * z**2]

print(sorted(monomials, reverse=True,
                           key=monomial_key('grevlex', [x, y, z])), '\n' )

print(degree_list(f), '\n' )


print('\n ',  '\n' )


print( 'RECURSIVE DIVISION Example 11', '\n' )
f = x**2 * y**2 + x
g = x * y + 1
print('f = ', f,'\n')
print('g = ', g,'\n')

print('LC(f, x) = ', LC(f, x), '\n')
print('LC(g, x) = ', LC(g, x), '\n')

print('LC(g, x) DIVIDES LC(f, x)', '\n')
print('step 1', '\n')

print('quo(f, g) = ', quo(f, g, domain = QQ[y]), '\n')
print('rem(f, g) = ', rem(f, g, domain = QQ[y]), '\n')

print('step 2 ??', '\n')

print('LC(g, x) = ', LC(g, x), '\n')
print('LC(rem(f, g), x) = ', LC(rem(f, g, domain = QQ[y]), x),'\n')
print('process STOPs because LC(rem(f, g), x) does NOT divide LC(g, x)','\n')
print('f = (x*y)* g + x*(-y + 1)','\n')
print('\n ','\n')



print( 'RECURSIVE DIVISION AGAIN; same polys different domain', '\n' )
f = x**2 * y**2 + x
g = x * y + 1
print('f = ', f,'\n')
print('g = ', g,'\n')

print('LC(f, y) = ', LC(f, y), '\n')
print('LC(g, y) = ', LC(g, y), '\n')

print('LC(g, y) DIVIDES LC(f, y)', '\n')
print('step 1', '\n')

print('quo(f, g) = ', quo(f, g, domain = QQ[x]), '\n')
print('rem(f, g) = ', rem(f, g, domain = QQ[x]), '\n')

print('step 2 ??', '\n')

print('LC(g, y) = ', LC(g, y), '\n')
print('LC(rem(f, g), y) = ', LC(rem(f, g, domain = QQ[x]), y),'\n')
print('process STOPs because LC(rem(f, g), x) does NOT divide LC(g, x)','\n')
print('f = (x*y - 1)* g + x + 1','\n')
print( '\n')

print('f does NOT have unique representation','\n')
print('f = (x*y)* g + x*(-y + 1)','\n')
print('f = (x*y - 1)* g + x + 1','\n')

from sympy import expand
print(expand((3*x - 5*y - 6)*(x*y + 2*y + 3*y**2)))


print('\n ','\n')
print('MONOMIAL BASED DIVISION Example 13', '\n')
print('main variable x', '\n')
f = 2*x**2 * y + 3*x**2 + 4*x*y + 5*x + 6*y + 7
g = x*y
print('f = ', f,'\n')
print('g = ', g,'\n')

print('LC(f, x) = ', LC(f, x), '\n')
print('LC(g, x) = ', LC(g, x), '\n')
print('RECURSIVE DIV STOPs because LC(g, x) does NOT divide LC(f, x)','\n')

print('quo(f, g) = ', quo(f, g, domain = QQ[y]), '\n')
print('rem(f, g) = ', rem(f, g, domain = QQ[y]), '\n')
print('\n')
print('HOWEVER, with monomial based division  we have', '\n')
print('monomial based division ::', reduced(f, [g]),'\n')
print('that is we have f = (2*x + 4) * g + 3*x**2 + 5*x + 6*y + 7', '\n')
print(f == expand( (2*x + 4) * g ) + 3*x**2 + 5*x + 6*y + 7, '\n')

print('Example 20: general monomial based division', '\n')
f = x**3 + 3*x**2*y + 4*x*y**2
g = x*y + 2*y + 3*y**2

print('f = ', f,'\n')
print('g = ', g,'\n')

print('recursive division fails; i.e. quo = 0','\n')
print('quo(f, g) = ', quo(f, g, domain = QQ[y]), '\n')
print('rem(f, g) = ', rem(f, g, domain = QQ[y]), '\n')
print('\n')

print('monomial division works','\n')
print('reduced monom division ::', reduced(f, [g]), '\n')

print('to obtain the above result use monomial x*y of g','\n')
print('LM(g) = ', LM(g), '\n' )

print('step 1', '\n')
print('reduced(f, [x*y]) ::', reduced(f, [x*y]), '\n')
q1 = reduced(f, [x*y])[0][0]
print('the quotient is q1 :: ', q1, 'and compute r1 = f - q1 * g ','\n')
r1 = simplify(  f - ([3*x + 4*y][0]) * g)
print('r1 = ', r1, '\n')

print('step 2', '\n')
print('reduced(r1, [x*y]) ::', reduced( r1, [x*y]), '\n')
q2 = reduced(r1, [x*y])[0][0]
print('the quotient is q2 :: ', q2, 'and the updated quotient is ',q1 + q2, '\n')
print('compute r2 = r1 - q2 * g ','\n')
r2 = simplify(r1 - q2 * g)
print('r2 = ', r2, '\n')

print('step 3 STOP ', '\n')
print('reduced(r2, [x*y]) ::', reduced( r2, [x*y]), '\n')


p = x**5 - 2*x**4 + 5*x**3 + 2*x**2 - 4*x + 10
q = x**3 - x**2 + 3*x + 5

print('quo :: ', quo(p, q))
print('rem :: ', rem(p, q))

t2 = rem(p, q)

p = q
q = t2

print('quo :: ', quo(p, q))
print('rem :: ', rem(p, q))
"""
